/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 04/08/2001                                                 */
/*                                                                           */
/* File: "cmodel.c"                                                          */
/*                                                                           */
/*****************************************************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <sys/signal.h>

#include "acticast_include.h"
#include "cmodel.h"

/*****************************************************************************/

void set_interrupt_flag();

/*****************************************************************************/

GLOBAL *g;
PPM tmp, med;

/***************************** Main program **********************************/

int main(int argc, char **argv)
{
  char str[256], *parameter_file = NULL;

  g = &GlobalVariables;
  default_global_variables(g);

  arg_parse(argc, argv,
            "", "Usage:",
	    "-param %S", &parameter_file, "set parameter file",
	    "-dumpAll [%d]", &g->dump_all_flag,
	    "dump all displayed images flag [%d]", g->dump_all_flag,
            NULL);

  (void) signal(SIGINT, set_interrupt_flag);

  set_global_variables(g, parameter_file, &ParameterTable[0], 
		       sizeof(ParameterTable)/sizeof(PARAMETERS));
  open_xdisplay(g->initial->im.p);

  if(strlen(&g->partitioned_file[0]) <= 0) {
    partition_image_global(g);
    show_and_save_image(g, &g->proc.im, 1);
  }

  //dump_class_file("test.class", &g->c);

  extract_image_global(g);

  raw2ppm(&g->display2.im, &tmp);
  //median_filter(&tmp, &med, 1, 0);
  //write_ppm_file("med_filtered.ppm", &med);
  
  return(1);
}

/*****************************************************************************/

void set_interrupt_flag()
{
  g->interrupt_flag = 1;
  return;
}

/*****************************************************************************/

