/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 2/25/2001                                                  */
/*                                                                           */
/* File: "ellipse.h"                                                         */
/*                                                                           */
/*****************************************************************************/

#define CONFIDENCE_INTERVAL 0.9

/*****************************************************************************/

extern int copy_ellipse(ELLIPSE *ein, ELLIPSE *eout);
extern int initialize_ellipse(ELLIPSE *e);
extern int compute_ellipse_bounds(ELLIPSE *e, double **x, int n, 
				  int transpose);
extern int mean_matrix(double *v, double **x, int n, int m, int transpose);
extern int covariance_matrix2x2(double cov[2][2], double **x, int n, 
				double *mean, int transpose);
extern int eigenvalues2x2(double *ev, double m[2][2]);
extern int major_eigenvector2x2(double *ev, double m[2][2]);
extern double ellipsoid_angle(double m[2][2]);
extern double ellipsoid_distance(double x);
extern int compute_ellipse(ELLIPSE *ell, double **x, int n, double ci,
			   int transpose);
extern int compute_ellipse_from_cov(ELLIPSE *ell, double ci);
extern int compute_ellipse_from_online(ELLIPSE *ell, int n);
extern int display_ellipse(FILE *fp, ELLIPSE *ell);
extern int selective_ellipse(ELLIPSE *e, double **x, 
			     int n, int transpose, int *type, int pick);
extern double log_likelihood(double *xy, ELLIPSE *e);
extern int compute_position_class_one(double *xy, ELLIPSE *e, int n_e);
extern int compute_position_class(BLOB2 *b, int *w, int n_w);

/*****************************************************************************/
