/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 03/02/2001                                                 */
/*                                                                           */
/* File: "mask.h"                                                            */
/*                                                                           */
/*****************************************************************************/

/****************************** Subroutines **********************************/

extern int convert_ppm_mask_to_mask_struct(PPM *im, MASK *m);
extern int read_mask_file(char *file, MASK *m);
extern int write_mask_file(char *file, MASK *m);
extern int read_search_region_file(char *file, BOUNDING_BOX *b);
extern int clear_mask(MASK *m);
extern int sort_mask_coord(MASK_COORD *v, int n);
extern int check_overlap(MASK_COORD *out, MASK_COORD *a, MASK_COORD *b);
extern int prep_mask_line(MASK_LINE *l);
extern int fix_mask_line(MASK_LINE *l);
extern int check_mask_coordinates(MASK_LINE *l, int index);
extern int create_mask(MASK *m, BOUNDING_BOX *b, int n_b);
extern int print_mask(FILE *fp, MASK *m);
extern int draw_mask(PPM *im, MASK *m);
extern int copy_masks(MASK *in, MASK *out);
extern int copy_mask_raw2_to_ppm2(RAW2 *in, PPM2 *out);
extern int copy_mask_ppm2_to_ppm2(PPM2 *in, PPM2 *out);
extern int difference_raw2(RAW2 *im2, RAW2 *im1, PPM2 *imout);
extern int difference_hsv_raw2(RAW2 *im2, RAW2 *im1, PPM2 *imout);
extern int threshold_ppm2(PPM2 *in, PPM2 *out, int t);
extern int change_bounding_box(BOUNDING_BOX *b, int n);
extern int dilate_bounding_box(BOUNDING_BOX *b);
extern int dilate_bounding_boxes(BOUNDING_BOX *b, int n_b);
extern int contract_bounding_box(BOUNDING_BOX *b);
extern int contract_bounding_boxes(BOUNDING_BOX *b, int n_b);

extern int copy_mask_raw2_to_raw2(RAW2 *in, RAW2 *out);
extern int difference_ppm2(PPM2 *im2, PPM2 *im1, PPM2 *imout);
