/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 2/13/2000                                                  */
/*                                                                           */
/* File: "median.h"                                                          */
/*                                                                           */
/*****************************************************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define MEDIAN_FILTER_VEC_MAX 100

int Red[MEDIAN_FILTER_VEC_MAX];
int Green[MEDIAN_FILTER_VEC_MAX];
int Blue[MEDIAN_FILTER_VEC_MAX];
int RedSort[MEDIAN_FILTER_VEC_MAX];
int GreenSort[MEDIAN_FILTER_VEC_MAX];
int BlueSort[MEDIAN_FILTER_VEC_MAX];

/*****************************************************************************/

extern int my_sort(int *vec, int n);
extern int median_int(int *vec, int n);
extern int compare_int(int *a, int *b);

extern int median_filter(PPM *imin, PPM *imout, int n, int t);
extern int median_filter_one(PPM *imin, PPM *imout, int n, int i, int j,
			     int t);
extern int find_closest(int rmed, int gmed, int bmed,
			int *rv, int *gv, int *bv, int count);
extern int median_filter_one_raw(RAW *imin, PPM *imout, int n, int i, int j);
extern int median_filter_raw(RAW *imin, PPM *imout, int n);

extern int median_filter_one_ppm2(PPM2 *in, PPM2 *out, 
				  int n, int i, int j, int t);
extern int median_filter_ppm2(PPM2 *in, PPM2 *out, int n, int t);
extern int median_filter_red_channel_ppm2(PPM2 *in, PPM2 *out, int n, int t);
extern int median_filter_red_channel_one_ppm2(PPM2 *in, PPM2 *out, 
					      int n, int i, int j, int t);

/*****************************************************************************/

extern int median_filter_one_raw2(RAW2 *in, PPM2 *out, int n, int i, int j, 
				  int t);
extern int median_filter_raw2(RAW2 *in, PPM2 *out, int n, int t);



