/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 04/08/2001                                                 */
/*                                                                           */
/* File: "partition_global.h"                                                */
/*                                                                           */
/*****************************************************************************/

#define FILE_NAME_MAX 1024

/*****************************************************************************/

typedef struct global_struct {
  char vq_file[FILE_NAME_MAX];
  char image_file[FILE_NAME_MAX];
  char image_out_prefix[FILE_NAME_MAX];
  char partitioned_file[FILE_NAME_MAX];
  char output_data_file[FILE_NAME_MAX];
  double cohesion_scale;
  int  rgb2hsv_flag;
  POINT grid;
  int **colors;
  int n_colors;
  int **uniq_colors;
  int n_uniq;
  int interrupt_flag;
  int dump_all_flag;
  int image_counter;
  int append_file_flag;
  PPM_DATA m;
  CLASS c, clean;
  PPM2 im_ppm, hsv_ppm, proc_ppm, *curr_ppm, total;
  RAW2 im, hsv, proc, *curr, *initial;
  RAW2 display1, display2;
  PPM2 tmp1, tmp2, tmp3, tmp4;
  int event_state;
  XEvent event;
  BOUNDING_BOX box_all;
  BLOB2 all[1];
  BLOB2 split[MAX_SPLIT_BLOBS];
} GLOBAL;

/*****************************************************************************/

extern int set_global_variables(GLOBAL *g, char *parameter_file,
				PARAMETERS *table, int n_params);
extern int default_global_variables(GLOBAL *g);
extern int partition_image_global(GLOBAL *g);
extern int partition_image_global_with_class(GLOBAL *g, CLASS *c,
					     int **colors, int n_colors);
extern int show_and_save_image(GLOBAL *g, RAW *im, int force);
extern int extract_image_global(GLOBAL *g);
extern int handle_extract_event(GLOBAL *g);
extern int clean_up_mask_image_partition(GLOBAL *g);
extern int gather_pixel_information_partition(GLOBAL *g, int x, int y);
extern int generate_mask_image_partition(GLOBAL *g, int x, int y);
extern int clean_up_partitioned_image(GLOBAL *g);
extern int clean_up_one_partition(GLOBAL *g, int *color);

/*****************************************************************************/
